clear all; close all
%
% Recursive Least Squares, 2 dim regression model: 
% yM(t)  = a + b u(t) + c u(t)^2
N=200; a=2; b=4; c=3;
u=sin(2*pi*[1:N]/N);
th=[ones(1,N); u; u.^2];                % design (regression, measurement) matrix
y=th'*[a b c]'+.1*randn(1,N);           % system = linear regression + noise
P=[1, 0, 0; 0, 1, 0; 0, 0, 1]; ll=.9*ones(1,N); % init quantities
aestv=zeros(1,N); bestv=zeros(1,N); cestv=zeros(1,N); parold=[aestv(1); bestv(1); cestv(1)];
for k=1:N, k
   aestv(k)=parold(1); bestv(k)=parold(2); cestv(k)=parold(3);
   LM=P*th(:,k)/(ll(k)+th(:,k)'*P*th(:,k));         % computing L coefficient
   parnew = parold + LM*(y(k)-th(:,k)'*parold);     % computing parameter updates
   Pnew=(P-P*th(:,k)*th(:,k)'*P/(ll(k)+th(:,k)'*P*th(:,k)))/ll(k);  % computing P matrix update
   P=Pnew; parold=parnew, %pause;                   % recursion
   figure(1), plot([1:N],aestv,'or',[1:N],bestv,'xb',[1:N],cestv,'*k'); grid;   % run-time illustration
end;







